
Core - Task # 56538

Epic # 55070 (Accepted): Workpackages
Epic # 55065 (New): WP: Overall System Performance (Backend and Frontend)
Bug # 52949 (Resolved): Speed decrease since 4.5
Bug # 56307 (Accepted): Findings from Bootstrap/PackageManager/ClassLoader analyses

Status: Resolved Priority: Should have
Author: Ernesto Baschny Category: Performance
Created: 2014-03-04 Assigned To: Thomas Maroschik
Updated: 2014-03-16 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity:
Sprint Focus:
Subject: Cache the $GLOBALS['TYPO3_LOADED_EXT'] as an array
Description

Several core components still access $GLOBALS['TYPO3_LOADED_EXT'] directly. Basically it's used to loop through the activated
extensions and also to check if some extension is installed.

Since the Package Management, this array is being simulated by an object (LoadedExtensionsArray). Plan was to be able to add
deprecation messages for accessing this array in future.

When accessing a FE with one USER_INT, accessing this object takes about 10% of the time.

It should be considered if we cannot generate the original array on first request, cache it, and then make the GLOBAL array available
again to whoever uses it. It's just a list of extensions. The gain of the future possibility of throwing a deprecation message opposed to
simply having this array as an array and be fast is probably not worth it.

Related issues:
duplicated by Core - Task # 56341: Evaluate if it is really reasonable to hav... Closed 2014-02-26

Associated revisions
Revision 64c46b91 - 2014-03-15 23:52 - Thomas Maroschik

[TASK] Improve performance of Bootstrap/PackageManager

This patch is a combined patch which tries to address
the findings from the Bootstrap/PackageManager/ClassLoader
performance analysis.

Resolves: #56934
Resolves: #56310
Resolves: #56331
Resolves: #56341
Resolves: #56538
Releases: 6.2
Change-Id: I269159906534f58eff59973ab30e170fadac10e4
Reviewed-on: https://review.typo3.org/28329
Reviewed-by: Ernesto Baschny
Tested-by: Ernesto Baschny
History
#1 - 2014-03-04 17:05 - Thomas Maroschik
- Status changed from New to Accepted
- Assigned To set to Thomas Maroschik

#2 - 2014-03-04 21:37 - Michiel Roos

It would be great if \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::isLoaded() could then just return a
isset($GLOBALS['TYPO3_LOADED_EXT']['extension']).

#3 - 2014-03-07 16:20 - Markus Klein

Actually this is a regression.

Using basic functions like array_keys() does not work on objects like this, so this is was a breaking change.

#4 - 2014-03-15 23:09 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28329

#5 - 2014-03-15 23:36 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28329

#6 - 2014-03-16 00:30 - Thomas Maroschik
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:64c46b918ef016bdd1d799c5ca06e868d601f692.
